// start with first tab and display it
var currentTab = 0;
showTab(currentTab);

function showTab(n) {
    var x = document.getElementsByClassName("teams-tab");
    x[n].style.display = "block";

    if (n == 0) {
        // first tab
        document.getElementById("prevBtn").style.display = "none";
        document.getElementById("infoBtn").style.display = "inline";
    } else {
        document.getElementById("infoBtn").style.display = "none";
        document.getElementById("prevBtn").style.display = "inline";
    }

    if (n == (x.length - 1)) {
        // last tab
        render_summary();
        document.getElementById("nextBtn").innerHTML = "Submit";
    } else {
        document.getElementById("nextBtn").innerHTML = "Next";
    }
    stepIndicator(n)
}

// fill content for summary page dynamically
function render_summary() {
    var div = $("#teams_sum");
    var re = /_sum$/;
    $(div).find("input").each(function () {
        $(this).val(document.getElementById(this.id.replace(re, "")).value);
    });

    if ($("#teams_cert_options").val() == "cert_custom") {
        $("#teams_opt_hostname_sum").val($("#teams_cert_custom_fqdn").val());
        $(".teams_txt_value_sum").hide();
    }
}

// submit form with ajax
function submitForm() {
    // display waiting gif
    document.getElementById("regForm").style.display = "none";
    document.getElementById("teamsWait").style.display = "block";
    document.getElementById("teams_header").style.display = "none";
    // collect form data
    var formData = new FormData($("form#regForm")[0]);

    $.ajax({
        type: "POST",
        url: "modules/Sip/teams_submit.php",
        data: formData,
        timeout: 5000,
        contentType: false, // required for file upload with ajax
        processData: false, // required for file upload with ajax
        //cache:false,
        success: function (data) {
            var json = $.parseJSON(data);
            if (json.status == 'success') {
                $('#teams_response').html(json.message).css("color", "green");
                document.getElementById('teams_header_sub').style.display = "inline-block";
                if (json.txt_error) {
                    $('#teams_txt_error').html(json.txt_error).css("color", "darkred");
                    document.getElementById("teams_txt_info").style.display = "block";
                }
                $('#txt_error').html
            } else if (json.status == 'error') {
                $('#teams_response').html('Setup Error: ' + json.message).css("color", "darkred");
            }
            document.getElementById("teamsWait").style.display = "none";
            document.getElementById("regForm").style.display = "block";
        },
        error: function (textStatus, errorThrown) {
            $('#teams_response').html('Server Error: ' + errorThrown);
            document.getElementById("teamsWait").style.display = "none";
            document.getElementById("regForm").style.display = "block";
        },
    });
    document.getElementById("teams_response").style.display = "block";
    document.getElementById("teams_buttons").style.display = "none";
    return true;
}

function nextPrev(n) {
    var x = document.getElementsByClassName("teams-tab");
    if (n == 1 && !validateForm()) return false;
    x[currentTab].style.display = "none";
    currentTab = currentTab + n;
    if (currentTab >= (x.length)) {
        submitForm(); // ajax request
        return true;
    }
    showTab(currentTab);
}

function validateForm() {
    var x, y, z, i, valid = true;
    x = document.getElementsByClassName("teams-tab");
    y = x[currentTab].getElementsByTagName("input");
    z = x[currentTab].getElementsByTagName("select");
    $(y).each(function () {
        if (!validator.element(this) && valid) {
            valid = false;
        }
    });
    $(z).each(function () {
        if (!validator.element(this) && valid) {
            valid = false;
        }
    });
    if (valid) {
        document.getElementsByClassName("step")[currentTab].className += " finish";
    }
    return valid;
}

function lastSlide() {
    var tabs = document.getElementsByClassName('teams-tab');
    for (var i = 0; i < tabs.length; i++) {
        tabs[i].style.display = "none";
    }
    document.getElementById("teams_header").style.display = "none";
    document.getElementById('teams_header_sub').style.display = "inline-block";
    document.getElementById("teams_buttons").style.display = "none";
}

function stepIndicator(n) {
    var i, x = document.getElementsByClassName("step");
    for (i = 0; i < x.length; i++) {
        x[i].className = x[i].className.replace(" active", "");
    }
    x[n].className += " active";
}

// TODO: optimize hiding/showing with array
function cert_option_toggle(val) {
    if (val == 'cert_custom') {
        $("div#teams_cert_custom").show();
        $("div#upload_cafile>div>input").prop("disabled", false);
        $("div#upload_key>div>input").prop("disabled", false);
        $("div#upload_crt>div>input").prop("disabled", false);
        $("input#teams_cert_custom_fqdn").prop("disabled", false);
        $("div#teams_txt_custom").show();

        $("div#teams_cert_beronet").hide();
        //$("div#teams_cert_custom").prop("disabled", false);
        $("div#teams_txt_beronet").hide();
        $("input#teams_txt_value").prop("disabled", true);
        $("div#teams_cert_skip").hide();


    } else if (val == 'cert_skip') {
        $("div#teams_cert_skip").show();
        $("div#teams_cert_beronet").hide();
        $("div#teams_cert_custom").hide();
        $("div#upload_cafile>div>input").prop("disabled", true);
        $("div#upload_key>div>input").prop("disabled", true);
        $("div#upload_crt>div>input").prop("disabled", true);
        $("input#teams_cert_custom_fqdn").prop("disabled", true);
        $("div#teams_txt_custom").hide();
        $("input#teams_txt_value").prop("disabled", true);

    } else {
        $("div#teams_cert_custom").hide();
        $("div#upload_cafile>div>input").prop("disabled", true);
        $("div#upload_key>div>input").prop("disabled", true);
        $("div#upload_crt>div>input").prop("disabled", true);
        $("input#teams_cert_custom_fqdn").prop("disabled", true);
        $("div#teams_txt_custom").hide();

        $("div#teams_cert_beronet").show();
        //$("div#teams_cert_custom").prop("disabled", false);
        $("div#teams_txt_beronet").show();
        $("input#teams_txt_value").prop("disabled", false);
        $("div#teams_cert_skip").hide();
    }
}

$(document).ready(function () {
    cert_option_toggle($("select#teams_cert_options").val());
    $('[data-toggle="tooltip"]').tooltip({ placement: 'auto bottom', html: true, trigger: 'hover' });
});

// ### event listener ###
$('select#teams_cert_options').change(function () {
    cert_option_toggle($("select#teams_cert_options").val());
});

