<?php

unset($_GET);
chdir("../..");
require_once ('./includes/session.php');

include_once("/usr/www/include/SQLite2ToSQLite3.php");
include ("./misc/database.php");
$ba = new beroAri();
$bc = new beroConf('root');
$sbcConf = parse_ini_file('/etc/beroNet/sbc.conf');

include ("./includes/variables.php");
include ("./misc/config_parameter.php");
require_once ('./includes/lang.php');

//get default fqdn if exist, to enable skip
$bc_fqdn = $bc->get('root', 'teams_fqdn');

//get ids and names array for validation
$peers['names'] = '"general"';
$peers['ids']   = '"0"';
$query_comp = $ba->select("SELECT * FROM sip");
while ($entry = $ba->fetch_array($query_comp)) {
	if ($entry['id'] != $_GET['id']) {
    $peers['names'].=',' . '"' . $entry['name'] . '"';
    $peers['ids'].=',' . '"' . $entry['id'] . '"';
  }
}

### functions ###

function teams_opt_peer_select($ba) {
    $query = $ba->select('SELECT * FROM sip ORDER BY id asc');
    $opt = "<option value='' selected>Choose SIP Peer to connect</option>";
    while ($entry = $ba->fetch_array($query)) {
      $opt.="<option value='".$entry['id'] ."'>".$entry['name']."</option>";
    }
    return $opt;
}

// render field with value form sbc.conf, click to copy
function teams_copy_field($conf, $var, $id, $name) {
   $value = $conf[$var];
   empty($value) && $value = 'unknown';

   $ret = "<div class='form-group $id' data-toggle='tooltip' title='$var'>
	  <label for='$id' class='col-sm-3 control-label'>" . $name . "</label>
		<div class='col-sm-8'>
	  	<button type='button' class='form-control input-sm' style='text-align: left;' id='$id' value='$value' readonly onclick='navigator.clipboard.writeText(\"$value\");'>$value</button>
	 	</div>
	</div>";
  return $ret;
}

// render uneditable field, js copies value in
function teams_summary($id, $name) {
  $ret = "<div class='form-group ". $id ."_sum'>
	  <label for='".$id."_sum' class='col-sm-3 control-label'>". $name ."</label>
		<div class='col-sm-8'>
	  	<input class='form-control input-sm' style='text-align: left;' id='". $id ."_sum' readonly></input>
	 	</div>
	</div>";
  return $ret;
}
?>

<script type="text/javascript" src="misc/script/teams.js"></script>

<script>

// ### validation rules ###
var validator = $("#regForm").validate({
    rules: {
        name: {
            required: true,
            specChar: true,
            checkBlank: true,
            alphanumeric: true,
            maxlength: 20,
            compareName: [<?php echo $peers['names'] ?>],
        },
        teams_opt_peer: {
            teamsOptPeer: [<?php echo $peers['ids'] ?>],
        },
        teams_cert_options: {
            required: true,
        },
        teams_txt_value: {
            teamsTxt: true,
        }
        /* TODO more validation rules */
    },
});

</script>

<div id='teamsWait' class='text-center' style='display:none;min-height:120px'>
  <img src='./includes/images/waitlogo1.gif' style='position: absolute; top: 50%; left: 50%; transform: translate(-50%, -50%);'>
</div>

<form id="regForm" method="post" class="form-horizontal" style="padding-left:15px" action="#" enctype="multipart/form-data">
  <pre id="teams_response" style="display:none;"></pre>
  <div id="teams_txt_info" style="display:none;">
    <p style="display: block; font-family: Menlo,Monaco,Consolas,Courier New,monospace; padding: 9.5px; margin: 0 0 10px;font-size: 13px;line-height: 1.42857143; color: #333;background-color: #f5f5f5;border: 1px solid #ccc; border-radius: 4px;">
      <span id="teams_txt_error"></span><br><br>
      Something went wrong setting the DNS-TXT Record required for verifying the domain through beroCloud.<br>
      Please set it manually with the "Verify Domain" button <a href="https://<?= $sbcConf['BEROCLOUD_ADDRESS'] ?>/sbc-vm/view?id=<?= $sbcConf['SBCVM_ID'] ?>#addtxtrecord">on beroCloud</a>
    </p>
</div>

  <div id="teams_header" style="display:inline-block;padding-left: 15px;">
    <h3>MS-Teams Wizard</h3>
    <p>Here you can setup this Cloud-SBC to connect with your Microsoft Teams Tenant. <br>Please create a different SIP Peer to connect before you proceed!<br></p>
    <p>Follow steps of the wizard or follow this guide: <a href="https://beronet.atlassian.net/wiki/spaces/PUB/pages/3378642945/Connect+to+Microsoft+Teams+Tenant+with+TLS" target="_blank">How to connect your SBC with MS Teams</a></p>
  </div>
  <div id="teams_header_sub" style="display:none;padding-left: 15px;">
    <p>After you have <a href="https://admin.microsoft.com/#/Domains/Wizard" target="_blank">added the domain,</a> you need to activate the domain to be able to use it for teams Microsoft Teams.</p>
    <p>For this, create a user:<br> <a href="https://admin.microsoft.com/#/users/:/adduser" target="_blank">Microsoft 365 Admin Center: Add an activation user</a></p></p>
    <hr>
    <h3>Last Steps</h3>
    <p><a href="https://admin.teams.microsoft.com/direct-routing/details/v2/settings/add" target="_blank">Microsoft Teams Admin Center: Add SBC to Direct Routing</a>
    <p>The following settings have to be adjusted:<p>
    <p style="margin-left:20px">
      SIP signaling port: <b>5061</b><br>
      Forward P-Asserted-Identity: <b>on</b>
    </p>
    <hr>
    <p>To assign a Teams user to Direct Routing follow these steps:</p>
     <p style="margin-left:20px">
      <a href="https://admin.teams.microsoft.com/direct-routing/v2" target="_blank">Create PSTN Usage Record</a><br>
      <a href="https://admin.teams.microsoft.com/direct-routing/v2/voice-routes" target="_blank">Add Voice Route</a><br>
      <a href="https://admin.teams.microsoft.com/policies/teamsonlinevoicerouting" target="_blank">Add PSTN Usage Record to the Voice Route Policy</a><br>
      <a href="https://admin.teams.microsoft.com/users" target="_blank">Assign Telephone Number to any Teams Account</a>
    </p>
  </div>

  <div style="float:right;">
		<img style="width:125px;margin-right:30px;" src="./includes/images/teams.svg"/>
  </div>

  <hr>

  <div class="teams-tab" id="teams_cert">
    <div>
      <h3>TLS Certificate</h3>
      <p>beroNet can provide a wildcard certificate to authenticate with Microsoft via TLS1.2.<br>You can use your own certificates too or skip this step if this is already configured.</p>
  </div>

 	<div class='form-group'>
  <label for='teams_cert_options' class='col-sm-3 control-label'><?php echo TEAMS_CERT_OPTIONS_DIS ?></label>
   	<div class='col-sm-8'>
      <select name='teams_cert_options' class='form-control input-sm' id='teams_cert_options'>
	      <option value='cert_bero' selected ><?php echo TEAMS_CERT_BERONET_DIS ?></option>
        <option value='cert_custom'><?php echo TEAMS_CERT_CUSTOM_DIS ?></option>
        <?php if ($bc_fqdn): ?>
          <option value='cert_skip'><?php echo TEAMS_CERT_SKIP_DIS ?></option>
        <?php endif; ?>
      </select>
    </div>
  </div>

  <hr>

  <div class="cert_beronet" id="teams_cert_beronet">
    <p>You will have to register beroNets domain for your Microsoft 365 Organization later. We will provide a certificate for you. Please continue!</p>
  </div>
  
  <div class="cert_skip" id="teams_cert_skip">
    <p>Skipping certificate and TXT verification. Creating connection for configured FQDN:</p>
    <div class='form-group '>
	    <label for='teams_skip_fqdn' class='col-sm-3 control-label'><?php echo TEAMS_CERT_FQDN_DIS ?></label>
		  <div class='col-sm-8'>
	  	  <input class='form-control input-sm' style='text-align: left;' id='teams_skip_fqdn' value='<?php echo $bc_fqdn ?>' readonly></input>
	 	  </div>
	  </div>
  </div>

  <div class="cert_custom" id="teams_cert_custom">
    <p>If you want to provide your own certificate, please make sure it requested at a certified CA  (<a href="https://ccadb-public.secure.force.com/microsoft/IncludedCACertificateReportForMSFT" target="_blank">List of certified CAs by Microsoft</a>)</p>
    <p>You also need your own domain and add a DNS record. The FQDN must point to the SBCs IP. (click to copy)</p>
    <p>The new FQDN will be applied in the config files, to authenticate with the correct domain at Microsoft.</p>
    <?php echo teams_copy_field($sbcConf, 'SBCVM_IP', 'teams_cert_custom_ip', TEAMS_CERT_PUBIP); ?>

    <br>
    <p>Please upload your files in the .pem format if possible!</p>

    <div class='form-group' id='upload_chain' data-toggle='tooltip' title='<?php echo UPLOAD_CERTIFICATE; ?>'>
			<label for='uploadfile_chain' class='col-sm-4 control-label'><?php echo SIP_STACKS_UPLOAD_CERTIFICATE_DIS ?>: Chain File (CA)</label>
			<div class='col-sm-8 form-checkbox'>
				<input type='file' size='48' name='uploadfile_chain' id='uploadfile_chain'>
			</div>
		</div>
		<div class='form-group' id='upload_privkey' data-toggle='tooltip' title='<?php echo UPLOAD_CERTIFICATE;?>'>
			<label for='uploadfile_privkey' class='col-sm-4 control-label'><?php echo SIP_STACKS_UPLOAD_CERTIFICATE_DIS ?>: Private Key</label>
			<div class='col-sm-8 form-checkbox'>
				<input type='file' size='48' name='uploadfile_privkey' id='uploadfile_privkey'>
			</div>
		</div>
    <div class='form-group' id='upload_cert' data-toggle='tooltip' title='<?php echo UPLOAD_CERTIFICATE; ?>'>
			<label for='uploadfile_cert' class='col-sm-4 control-label'><?php echo SIP_STACKS_UPLOAD_CERTIFICATE_DIS ?>: Certificate</label>
			<div class='col-sm-8 form-checkbox'>
				<input type='file' size='48' name='uploadfile_cert' id='uploadfile_cert'>
			</div>
		</div>
  </div>

</div>

<div class="teams-tab" id="teams_options">
  <h3>Additional Configuration</h3>
  <p>Please give your new Microsoft Teams SIP account a name and choose the SIP Account it should connect to.<br>The Dialplan rules are automatically created. You can adjust the settings later.</p>
  <div class='form-group name' data-toggle='tooltip' title='<?php echo TEAMS_OPT_NAME_TT; ?>'>
	  <label for='name' class='col-sm-3 control-label'><?php echo TEAMS_OPT_NAME_DIS; ?></label>
		<div class='col-sm-8'>
	  	<input class='form-control input-sm' name='name' id='name' value=''>
	 	</div>
	</div>

  <div class='form-group'>
  <label for='teams_opt_peer' class='col-sm-3 control-label'><?php echo TEAMS_CERT_OPTIONS_PEER ?></label>
   	<div class='col-sm-8'>
      <select class='form-control input-sm' name='teams_opt_peer' id='teams_opt_peer'>
	      <?php echo teams_opt_peer_select($ba); ?>
      </select>
    </div>
  </div>

</div>

<div class="teams-tab" id="teams_txt">
  <h3>Register Domain at Microsoft 365 and Microsoft Admin Center</h3>

  <div class="cert_beronet" id="teams_txt_beronet">
    <p>When registering the domain at Microsoft, please choose the TXT Verification option and enter the provided value down below.<br>We will automatically create a DNS-TXT record to verify this sub-domain.</p>
    <p><a href="https://admin.microsoft.com/#/Domains/Wizard" target="_blank">Microsoft 365 Admin Center: Add Domain</a>

    <?php echo teams_copy_field($sbcConf, 'DOMAIN_NAME', 'teams_opt_hostname', TEAMS_OPT_HOSTNAME); ?>

    <div class='form-group' data-toggle='tooltip' title='<?php echo TEAMS_TXT_VALUE_TT ?>'>
		  <label for='teams_txt_value' class='col-sm-3 control-label'><?php echo TEAMS_TXT_VALUE ?></label>
		  <div class='col-sm-8'>
			  <input type='text' class='form-control input-sm' id='teams_txt_value' name='teams_txt_value' placeholder="MS=msXXXXXXXX">
		  </div>
	  </div>
  </div>

  <div class="cert_custom" id="teams_txt_custom">
    <p>When registering the domain at Microsoft, verify your domain with the method of your choice (TXT is recommended)<br>You will have to create a DNS-TXT record for the provided sub-domain.</p>
    <p><a href="https://admin.microsoft.com/#/Domains/Wizard" target="_blank">Microsoft 365 Admin Center: Add Domain</a>
  </div>
</div>

<div class="teams-tab" id="teams_sum">
  <h3>Summary of your settings</h3>
  <p>After you click submit, your config will be created. After that there are a few more steps left, <b>please don't close the window!</b></p>
  <?php echo teams_summary('teams_cert_options',  TEAMS_CERT_OPTIONS_DIS); ?>
  <?php echo teams_summary('teams_opt_hostname',  TEAMS_OPT_HOSTNAME); ?>
  <?php echo teams_summary('name',                TEAMS_OPT_NAME_DIS); ?>
  <?php echo teams_summary('teams_opt_peer',      TEAMS_CERT_OPTIONS_PEER); ?>
  <?php echo teams_summary('teams_txt_value',     TEAMS_TXT_VALUE); ?>
</div>

<!--  ### modal footer ### -->

<div id="teams_buttons" style="text-align:center;overflow:auto;">
    <button type="button" class="btn btn-default" id="infoBtn" onclick="lastSlide()">Teams Setup Links</button>
    <button type="button" class="btn btn-default" id="prevBtn" onclick="nextPrev(-1)">Previous</button>
    <button type="button" class="btn btn-default" id="nextBtn" onclick="nextPrev(1)">Next</button>
</div>

<div style="text-align:center;margin-top:40px;">
  <span class="step"></span>
  <span class="step"></span>
  <span class="step"></span>
  <span class="step"></span>
</div>

<br>

</form>